функция перевода числа в любую систему счисления до 10
вместо X ставите любое число, например "3"
def f(n):
    s = ''
    while n > 0:
        s = str(n % X) + s
        n = n // X
    return s
 
Питоновская функция перевода в 2,8,16

x = bin(n)[2:]
x = oct(n)[2:]
x = hex(n)[2:]
 
обратно в 10 сс

r = int(n,2) # вместо "2" - та система из которой переводим обратно в 10 сс

сумма единиц или нулей
if x.count('1') or x.count('0'):

Срезать 2 первых или 2 последних знака

x = x[2:]
x = x[:-2]

Добавить единицу в конец

x = x + '1'

добавить единицу в начало

x = '1' + x

убрать 3 первых знака и вставить туда единицу

x = '1' + x[3:]

Поменять последний и первый разряд местами
x = x[-1] + x[1:-1] + x[0]

Сумма цифр числа
s = sum(map(int,s)) #s - строка


произведение цифр числа
from math import *
s = prod(map(ints))